# Paypal payments

PayPal payments are a type of payment source that lets you process payments through [PayPal gateways](/core-api-reference/paypal_gateways.md).

PayPal payments can be created and associated with an order in a few steps:

1. [Create a PayPal payment](https://docs.commercelayer.io/core-api-reference/spaces/-Lk-ezuDClaMavTqnRi0/pages/-MNPUNqqM5swfJJbGCTx#2.-create-the-payment-source-and-associate-it-with-the-order), passing a valid `return_url` and `cancel_url`
2. Get the `approval_url` from the response
3. Redirect the customer to the approval URL
4. Get the `paypal_payer_id` from the return URL parameters
5. [Update the PayPal payment with the payer ID](/how-tos/placing-orders/payments/paypal/preparing-the-payment-for-execution.md)

{% hint style="info" %}
PayPal payments are **one-time payment sources** and cannot be saved in customer wallets.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.commercelayer.io/core-api-reference/paypal_payments.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
